from logging import DEBUG
from mandaye.exceptions import ImproperlyConfigured

# Mandaye configuration
host = '127.0.0.1'
port = 8088

debug = False
log_level = DEBUG

# Needed if ssl is activated
ssl = False
keyfile = ''
certfile = ''

# Template directory
template_directory = 'mandaye/templates'
# Static folder
static_root = 'mandaye/static'

# Database configuration
# rfc 1738 http://rfc.net/rfc1738.html
db_url = 'sqlite:///test.db'

hosts = {
        'localhost:8088': [
            {'path': r'/',
              'target': 'http://perdu.com',
              'mapping': None
              },
            ],
        }

#example_mapping = [
#            {
#            'path': r'/'
#            'on_response': [{
#                'filter': 'module.path.to.my_filter',
#                'values': {}
#                }]
#            },
#           {
#            'path': r'/test$'
#            'method': 'GET',
#            'response': [{
#                'filter': 'my_test',
#                'values': {
#                    'toto': 'titi',
#                    }
#                }]
#            },
#]

# beaker session
session_opts = {
        'session.type': 'file',
        'session.cookie_expires': True,
        'session.data_dir': '/tmp',
        'session.expire': 3600,
}

# Import local settings
try:
    from mandaye.local_config import *
except ImportError, e:
    if not 'local_config' in e.args[0]:
        raise ImproperlyConfigured('Error while importing "local_config.py"')

